#!/bin/sh
# compress a folder  -gzip or xz formats

# start with empty field
rm -f /tmp/DIR_SELECT

  
###############################################
#                                             #
#              COMPRESSION                    #
#                                             #
###############################################
  
compression(){
if [ -n  "$DIR_gtkdialog"  ] ; then
DIR="$DIR_gtkdialog"
fi
DIR3="$DIR"
DIR2="$DIR"/
# remove double slash at end of path (if it exists) 
DIR=`echo "$DIR2" | sed 's/\/\///'`
# if final character of DIR is slash then remove it
if [  "${DIR:(-1)}" = "/" ]; then 
DIR="$DIR3"
fi
# find directory that will be compressed by removal between slashes
DIRECTORY="${DIR##/*/}"

# move to directory that will be compressed
cd "$DIR"
cd ..
if [  "$GZIP_value" = "true" ] ; then
tar cvzf "$DIRECTORY".tar.gz "$DIRECTORY"
Xdialog --title "Compress"   --wrap --screen-center --left --no-buttons --msgbox  "Archive name:  $DIRECTORY.tar.gz
Storage location:   $PWD  "   10 55 100  & 
else 
tar cvJf "$DIRECTORY".txz "$DIRECTORY"
Xdialog --title "Compress"   --wrap --screen-center --left --no-buttons --msgbox  "Archive name:  $DIRECTORY.txz
Storage location:   $PWD  "   10 55 100  & 
fi
rm -f /tmp/DIR_SELECT

exit 0
}
export -f compression

touch /tmp/DIR_SELECT

###############################################
#                                             #
#               M A I N   G U I               #
#                                             #
###############################################

export COMPRESS='
<window title="Compression Demo " icon-name="mini-modules" resizable="false" decorated="true">
<vbox   width-request="310">
 <notebook labels="Xdialog|gtkdialog">
<vbox>
        <text height-request="40"><label>"Choose a folder
using Xdialog"</label></text>

 <hbox>       
<entry tooltip-text="Enter folder to compress">
     <input>cat "/tmp/DIR_SELECT"</input>
     <variable>DIR</variable>     
</entry> 
<button tooltip-text="Select folder to compress">
      <input file stock="gtk-open"></input>
       <action>Xdialog --title "Please choose a directory" --stdout --no-buttons  --dselect "$HOME" 30 55 > /tmp/DIR_SELECT</action>       
      <action>refresh:DIR</action>           
</button>
</hbox>

<radiobutton>
        <label>"GZIP compression"</label>
        <default>true</default>
        <variable>GZIP_value</variable>
</radiobutton>
<radiobutton>
        <label>"XZ compression"</label>
        <variable>XZ_value</variable>
</radiobutton> 
        <text height-request="25"><label>""</label></text>
        <text><label>____________________________________</label></text>
        
<hbox homogeneous="true">

 <button>
        <input file stock="gtk-cancel"></input>
        <label>Cancel</label>
        <action type="exit">CLOSE</action>
</button>

<button can-default="true" has-default="true" use-stock="true">
      <input file stock="gtk-ok"></input>
      <label>"COMPRESS"</label>
      <action>compression &</action>  
      <action type="exit">CLOSE</action>           
</button>     
</hbox>
</vbox>







<vbox>
        <text height-request="40"><label>"Choose a folder
using gtkdialog"</label></text>

 <hbox>       
        <entry accept="directory">
        <label>Select a Directory</label>
        <variable>DIR_gtkdialog</variable>
        </entry>
        <button>
        <input file stock="gtk-open"></input>
        <action type="fileselect">DIR_gtkdialog</action>        
       </button>   
</hbox>

<radiobutton>
        <label>"GZIP compression"</label>
        <default>true</default>
        <variable>GZIP_value</variable>
</radiobutton>
<radiobutton>
        <label>"XZ compression"</label>
        <variable>XZ_value</variable>
</radiobutton> 

        <text height-request="25"><label>""</label></text>
        <text><label>____________________________________</label></text>
        
<hbox homogeneous="true">

 <button>
        <input file stock="gtk-cancel"></input>
        <label>Cancel</label>
        <action type="exit">CLOSE</action>
</button>

<button can-default="true" has-default="true" use-stock="true">
      <input file stock="gtk-ok"></input>
      <label>"COMPRESS"</label>
      <action>compression &</action>  
      <action type="exit">CLOSE</action>           
</button>     
</hbox>
</vbox>

 </notebook>

</vbox>

</window>'

gtkdialog3  --geometry=+200+100 -p COMPRESS


